#!/bin/bash

# to install:
# cd $HOME/workspace/iqportal; rm .git/hooks/pre-commit; ln -s $HOME/workspace/iqportal/related/bin/git-pre-commit.sh $HOME/workspace/iqportal/.git/hooks/pre-commit

# exit 1 on any error
set -e

# this part comes from the git pre-commit.sample
if git rev-parse --verify HEAD >/dev/null 2>&1
then
        against=HEAD
else
        # Initial commit: diff against an empty tree object
        against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi

# Redirect output to stderr.
exec 1>&2

# If there are whitespace errors, print the offending file names and fail.
git diff-index --check --cached $against --

# iqportal specific checks start here..

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
IQPORTAL_DIR=$DIR/../../

# get git modified files
modified_files=$(git status --porcelain | awk 'match($1, "M"){print $2}')
for file in $modified_files; do

    # if its a .js file..
    if [[ "$file" == *js ]]; then

        # if its in a 'modules' dir, then use eslint
        if [[ "$file" == *modules/* ]]; then
            $IQPORTAL_DIR/node_modules/.bin/eslint_d -c $IQPORTAL_DIR/.eslintrc $file

        # else check if its a legacy yui file
        elif [[ "$file" == *media/*-debug.js ]]; then
            jsl -nosummary -nologo -process $file
        fi

    fi

    # TODO; maybe check python files via pylint?

done

echo 'git-pre-commit.sh: all coolio'
