#!/usr/bin/env python
# Copyright (c) 2018 BaseSoft B.V.
# See LICENSE for details.

import sqlalchemy, datetime
from sqlalchemy.orm import scoped_session, sessionmaker
from twisted.python.reflect import namedAny

from django.conf import settings

db_engine = sqlalchemy.create_engine(settings.DB_CONNSTR, echo=False)
session = scoped_session(sessionmaker(bind=db_engine, autoflush=True, autocommit=True))
conn = db_engine.connect()
metadata = sqlalchemy.MetaData(db_engine)

tables = []

for app in settings.INSTALLED_APPS:
    try:
        sa_module = namedAny(app+'.sa_datamapper')
    except AttributeError, e:
        continue

    if hasattr(sa_module, 'reset'):
        sa_module.reset()

    if hasattr(sa_module, 'do_tables'):
        sa_module.do_tables(metadata)
        tables += [table for table in sa_module.tables.keys() if table[:3] != 'agg' and 'Mock' not in table]

print 'mysqldump -uroot -p "iqportal_stable" %(tables)s | gzip > weee-eu-stable%(ts)s.SQL.gz' % {
    'tables': ' '.join(tables),
    'ts': datetime.datetime.now().strftime('%Y%m%d')
}
