from django.utils.translation import ugettext as _

from basesoft.web.core.exceptions import PublicUserException
from iqportal.datasources.oxford.controllers import OxfordController
from iqportal.iqube.core.controllers import ItemResultController


class OxfordHandler:

    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.account_id = request.session['user_id']
        self.controller = OxfordController(self.sa_session, account_id=self.account_id)

    def import_data(self, oxford_id):
        self.controller.import_data(oxford_id)

    def get_available_databanks(self):
        return self.controller.get_available_databanks()

    def get_cube_names(self):
        return self.controller.get_cube_names()

    def make_configurable_widget_config(self, databank_id):
        return self.controller.make_configurable_widget_config(int(databank_id))

    def get_filter_tree(self, cube_name):
        return self.controller.get_filter_tree(cube_name)

handlers = (OxfordHandler, )

